;-------------------------------------------
; Hard disk drive performance monitoring
; tool by Tomas Pribyl and Josef Soucek
;
; 17.9.2000 V0.1
;-------------------------------------------
      *= $60

opa0  *=*+1
opa1  *=*+1
opa2  *=*+1
opa3  *=*+1
opb0  *=*+1
opb1  *=*+1
opb2  *=*+1
opb3  *=*+1
opc0  *=*+1
opc1  *=*+1
opc2  *=*+1
opc3  *=*+1
opd0  *=*+1
opd1  *=*+1
opd2  *=*+1
opd3  *=*+1
pom8  *=*+1
;pom1  *=*+1
;pom2  *=*+1

      .include "kernal.asm"
      
;--------------------------------------
;basic line for starting programs

               * = $0801
            
               .byte $1b,$08,$0a,$00,$9e ;SYS
               .byte "2096"              ;$0830
               .byte $3a                 ;:
               .byte $8f," T.PRIBYL 2000",0,0,0

               * = $0830
               
               jsr $ff81         ;CINT
               jsr $ff84         ;IOINIT
               
               lda #<head_inf
               ldx #>head_inf
               jsr print_str
               
               jsr mk_dir
               jsr cd_dir
               jsr mk_file

               lda #<speed1_inf
               ldx #>speed1_inf
               jsr print_str
               
               jsr load_print_perf
               
               lda #<jedn_inf
               ldx #>jedn_inf
               jsr print_str
               
               lda #<speed2_inf
               ldx #>speed2_inf
               jsr print_str

               sei                  ;IRQ off
               lda #0               ;screen off
               sta 53248+17
               jsr load_print_perf
               lda #27
               sta 53248+17
               cli
               
               lda #<jedn_inf
               ldx #>jedn_inf
               jsr print_str

               lda #<delete_inf
               ldx #>delete_inf
               jsr print_str
               
               jsr rm_file
               jsr cd_root
               jsr rm_dir
               jsr clall
               rts                  ;### END

;--------------------------------------
load_print_perf = *
               ldx $ba
               ldy #1
               jsr setlfs
                  
               lda #name_end-[name+2]
               ldx #<name+2
               ldy #>name+2
               jsr setnam

               jsr starttime
 
               lda #0                ;load/verify
               jsr load
               
               ldx #opb0
               jsr savetime
               
               ldx #4
lomeno_16      = *
               lsr opb3
               ror opb2
               ror opb1
               ror opb0
               dex
               bne lomeno_16
                               ;49152(delkaFile)*985248(FI2)/16(pro rozsah)
                               ;Konst. b4678000
               lda #$00
               sta opa0
               lda #$80
               sta opa1
               lda #$67
               sta opa2
               lda #$b4
               sta opa3
               
               jsr deleni
               
               lda opc0
               sta opa0
               lda opc1
               sta opa1
               lda opc2
               sta opa2
               jsr asciinum
               rts
;--------------------------------------
cd_root        = *
               lda #3
               ldx #<rootname
               ldy #>rootname
               jmp comm_cont
rm_file        = *
               lda #"S"
               sta name
               lda #name_end-name
               ldx #<name
               ldy #>name
               jmp comm_cont
mk_dir         = *
               lda #"M"
               .byte $2c
cd_dir         = *
               lda #"C"
               .byte $2c
rm_dir         = *
               lda #"S"
               sta inputname

               lda #endname-inputname
               ldx #<inputname
               ldy #>inputname
comm_cont      = *
               jsr setnam
                                  
               ldx $ba
               ldy #15              ;command  
               lda #1               ;c.souboru
               jsr setlfs
                  
               jsr open
               lda #1
               jsr close
               rts
;--------------------------------------
rootname       .text "C:/"
inputname      .text "X:/.PERFORMANCEDIR"
endname        = *
name           .text "@:TESTPERFORMANCE"
name_end       = *
;--------------------------------------
mk_file        = *
               lda #$01
               ldx $ba
               ldy #$00
               jsr setlfs

               lda #"@"
               sta name
               
               lda #name_end-name
               ldx #<name
               ldy #>name
               jsr setnam
               
               lda #<$1000   ;pocatek
               sta $fb
               lda #>$1000
               sta $fc
               
               lda #$fb
               
               ldx #<$cffe   ;konec => 49152
               ldy #>$cffe
               jsr save
               rts
;--------------------------------------
; DELENI DVOU 4-bajtovych cisel
;
; opc=opa/opb    opd=zbytek    pom8=pom.
;
;--------------------------------------
deleni   = *
         lda #0   ;nuluje vysledek
         sta opc0
         sta opc1
         sta opc2
         sta opc3
         
         sta opd0 ;nuluje dilci
         sta opd1 ;podily (zbytek)
         sta opd2
         sta opd3
;---------------------------------------
         lda opb0  ;test na deleni 0
         ora opb1
         ora opb2
         ora opb3
         bne divi ;nelze delit nulou
                  ;deleni nulou error
         lda #$08
         sta $d020
         rts
divi     = *
;---------------------------------------
         lda opa0 ;test na delenec=0
         ora opa1
         ora opa2
         ora opa3
         bne ruzni
         rts      ;vysledek je 0
;---------------------------------------
;hlavni delici rutina,delenec i delitel
;jsou ruzni od 0
;---------------------------------------
ruzni    ldx #0     ;pocet cifer
         stx pom8   ;inituji

ruzni1   jsr odecet ;hledam 1 dilci
                    ;delenec
         bcc hledej

delit    jsr odecet ;odecte delitele
                    ;od dilciho podilu

         bcc dalsi  ;vysledek<0
                    ;musim sepsat
                    ;dalsi cifru
                       
         sta opd3   ;odecteni o.k.
         stx opd2   ;ulozim novy
         sty opd1   ;dilci delenec
         lda hlplow
         sta opd0

         inc opc0   ;vysledek + 01

         jmp delit
;---------------------------------------
hledej   jsr next1  ;hledani 1 dilciho
         jmp ruzni1 ;delence
;---------------------------------------
dalsi    jsr next1  ;sepsat dalsi cifru
         jsr vysled ;posunout vysledek
         jmp delit  ;pokracovat v deleni
;---------------------------------------
;vlozi dalsi cifru <4bity> z delence
;do pomocne promenne
; a otestuje, kolik jich uz vlozil
;---------------------------------------
next1    inc pom8   ;dalsi cifra
         lda pom8   ;sepsana
         cmp #9     ;je uz posledni?
         beq enddiv ;konec deleni

         ldy #4
posun2   asl opa0
         rol opa1
         rol opa2
         rol opa3
 
         rol opd0
         rol opd1
         rol opd2
         rol opd3
         dey
         bne posun2
         rts
         
enddiv   = *
                  ;jelikoz jsem v pod-
                  ;programu,
         pla      ;vyndam ze zasobniku
         pla      ;navratovou adresu
         rts      ;abych se moh vratit
                  ;do basicu
;---------------------------------------
odecet   sec
         lda opd0   ;od dilciho podilu
         sbc opb0   ;odecte delitele
         sta hlplow ;ulozi
         lda opd1
         sbc opb1
         tay
         lda opd2
         sbc opb2
         tax
         lda opd3
         sbc opb3
         rts
hlplow   .byte 0      
;---------------------------------------
vysled   ldy #4    ;rotace vysledku 4x
posun1   asl opc0  ;posunu o rad vyse
         rol opc1
         rol opc2
         rol opc3
         dey
         bne posun1
         rts
;---------------------------------------
;nuluje promene
;---------------------------------------
clear_c  = *
         lda #0
         sta opa0
         sta opa1
         sta opa2
         sta opa3
         sta opb0
         sta opb1
         sta opb2
         sta opb3
         rts
         
;---------------------------------------
; Tiskne na std. vystup dekadicke cislo
; cislo = opa0 - opa2
; pouziva opb0 ... (4+2 bytes)       
;---------------------------------------
asciinum = *   
         lda #0
         ldx #4    
cl_bcd   = *         
         sta opb0,x
         dex
         bpl cl_bcd   
         
       ; ldy #32 
         ldy #24
         sei
         sed         ;prepne do DEC modu

nextbit = *
        asl opa0
        rol opa1
        rol opa2
        ldx #3
add_bcd = *        
        lda opb0,x
        adc opb0,x
        sta opb0,x
        dex
        bpl add_bcd
        dey
        bne nextbit
        cld
        cli
              
                       
        lda #8
        sta opb0+5           ;priznak
        ldx #0
bcd_byte = *        
        lda opb0,x
        jsr utoaPutHex
        inx
        cpx #4
        bcc bcd_byte  
        
        rts
;-------------- 
utoaPutHex = *
            pha
            lsr
            lsr
            lsr
            lsr              ;horni 1/2 byte
            jsr utoaPutDigit
            pla
            and #$0f         ;spodni 1/2 byte

utoaPutDigit = *
            bne exist_num    ; kdyz je cislo nenulove jde na tisk
            dec opb0+5
            ldy opb0+5
            beq exist_num    ;kdyz priznak je 0  tzn. vytiskne posledni 0
            cpy #8
            bcs exist_num    ;kdyz priznak je => 8 tzn. uz nekdy bylo ne0 cislo
            rts              ; *** nuly na zacatku vynechava ***
exist_num   = *
            ora #$30
            sta opb0+5       ;priznak
            jsr chrout
            rts
;--------------------------------------
; A= low, x = hi
;--------------------------------------
print_str   = *
            sta point+1
            stx point+2
            ldx #0
point       lda 1000,x
            beq print_str_end
            jsr chrout
            inx
            bne point
            inc point+2
            jmp point
print_str_end = *
            rts
;--------------------------------------
head_inf       .text "         IDE64 HARD DISK DRIVE",$0d
               .text " LOAD SPEED PERFORMANCE MONITORING TOOL",$0d
               .text " V0.1 (C) 2000 BY T.PRIBYL AND J.SOUCEK",$0d
               .text "----------------------------------------",$0d,0
               .text "CREATING TEST DIR AND FILE",$0d,$0d,0
delete_inf     .text "REMOVING TEST FILE AND DIR",$0d,0
speed1_inf     .text "LOAD SPEED WITH IRQ AND SCREEN ON",$0d
               .text "---------------------------------",$0d,0
speed2_inf     .text "LOAD SPEED WITH IRQ AND SCREEN OFF",$0d
               .text "----------------------------------",$0d,0
jedn_inf       .text " BYTES PER SECOND",$0d,$0d,0
;--------------------------------------
         .include "timers.asm"
